local assets=
{
	Asset("ANIM", "anim/cane.zip"),
	Asset("ANIM", "anim/swap_cane.zip"),
    Asset("INV_IMAGE", "cane"),
    
}

local function onattack_aoe(inst, attacker, target)
    local atkfx = SpawnPrefab("explode_small")
    if atkfx then
	    local follower = atkfx.entity:AddFollower()
	    follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
	end

    if attacker and attacker.components.health and attacker.components.hunger then
        attacker.components.health:DoDelta(0.5)
		attacker.components.hunger:DoDelta(-0.3)
                        attacker.components.sanity:DoDelta(0.3)
    end

    if not target:IsValid() then
        --target killed or removed in combat damage phase
        return
    end
    
    if target.components.sleeper and target.components.sleeper:IsAsleep() then
        target.components.sleeper:WakeUp()
    end
    if target.components.burnable then
        if target.components.burnable:IsBurning() then
            target.components.burnable:Extinguish()
        elseif target.components.burnable:IsSmoldering() then
            target.components.burnable:SmotherSmolder()
        end
    end

    if target.sg ~= nil and not target.sg:HasStateTag("frozen") then
        target:PushEvent("attacked", { attacker = attacker, damage = 0 })
    end

    if target.components.freezable then
        target.components.freezable:AddColdness(1)
        target.components.freezable:SpawnShatterFX()
    end
end

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
inst.Light:Enable(true)
    owner.components.combat:SetAreaDamage(3, 1)
    owner.AnimState:OverrideSymbol("swap_object", "swap_cane", "swap_cane")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
inst.Light:Enable(false)
    owner.components.combat:SetAreaDamage(nil, nil)
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()        
    MakeInventoryPhysics(inst)
    --多用工具
    anim:SetBank("cane")
    anim:SetBuild("cane")
    anim:PlayAnimation("idle")
    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 15)
    inst.components.tool:SetAction(ACTIONS.MINE, 6)
    inst.components.tool:SetAction(ACTIONS.NET)
    inst.components.tool:SetAction(ACTIONS.HACK,15)
	
	
    inst:AddComponent("blinkstaff")
    local light = inst.entity:AddLight()
    light:SetFalloff(0.4)
    light:SetIntensity(.7)
    light:SetRadius(3.5)
    light:SetColour(255/255,255/255,192/255)--十胜石工具的光色
    light:Enable(true)
	
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(53)
    inst.components.weapon:SetRange(10, 12)
    inst.components.weapon:SetOnAttack(onattack_aoe)
    inst.components.weapon:SetProjectile("ice_projectile")
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    
    inst:AddComponent("equippable")
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    inst.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT
    
    return inst
end


return Prefab( "common/inventory/cane", fn, assets) 

